<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageInsurance ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageInsurance extends AbstractStructArrayBase
{
    /**
     * The Insurance
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageInsurance[]
     */
    public $Insurance;
    /**
     * Constructor method for ArrayOfJP_PackageInsurance
     * @uses ArrayOfJP_PackageInsurance::setInsurance()
     * @param \StructType\JP_PackageInsurance[] $insurance
     */
    public function __construct(array $insurance = array())
    {
        $this
            ->setInsurance($insurance);
    }
    /**
     * Get Insurance value
     * @return \StructType\JP_PackageInsurance[]|null
     */
    public function getInsurance()
    {
        return $this->Insurance;
    }
    /**
     * This method is responsible for validating the values passed to the setInsurance method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsurance method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsuranceForArrayConstraintsFromSetInsurance(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageInsuranceInsuranceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageInsuranceInsuranceItem instanceof \StructType\JP_PackageInsurance) {
                $invalidValues[] = is_object($arrayOfJP_PackageInsuranceInsuranceItem) ? get_class($arrayOfJP_PackageInsuranceInsuranceItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageInsuranceInsuranceItem), var_export($arrayOfJP_PackageInsuranceInsuranceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Insurance property can only contain items of type \StructType\JP_PackageInsurance, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Insurance value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageInsurance[] $insurance
     * @return \ArrayType\ArrayOfJP_PackageInsurance
     */
    public function setInsurance(array $insurance = array())
    {
        // validation for constraint: array
        if ('' !== ($insuranceArrayErrorMessage = self::validateInsuranceForArrayConstraintsFromSetInsurance($insurance))) {
            throw new \InvalidArgumentException($insuranceArrayErrorMessage, __LINE__);
        }
        $this->Insurance = $insurance;
        return $this;
    }
    /**
     * Add item to Insurance value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageInsurance $item
     * @return \ArrayType\ArrayOfJP_PackageInsurance
     */
    public function addToInsurance(\StructType\JP_PackageInsurance $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageInsurance) {
            throw new \InvalidArgumentException(sprintf('The Insurance property can only contain items of type \StructType\JP_PackageInsurance, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Insurance[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageInsurance|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageInsurance|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Insurance
     */
    public function getAttributeName()
    {
        return 'Insurance';
    }
}
